.globl _start
_start:
	mov sp,#0x10000
	@ r0 = g, r1 = h, r2 = I, r3 = j, r4 = f
	mov r0,#5
	mov r1,#4
	mov r2,#6
	mov r3,#7
	mov r4,#0
	bl ex
	bl ex
	bl ex
	bl ex

iloop:	b	iloop		@ infinite loop (for "termination")

ex:	@ label for function name
	SUB sp, sp, #12  @ adjust stack to make room for 3 items
	STR r6, [sp,#8]  @ save register r6 for use afterwards
	STR r5, [sp,#4]  @ save register r5 for use afterwards
	STR r4, [sp,#0]  @ save register r4 for use afterwards

	ADD r5,r0,r1	@ register r5 contains g + h
	ADD r6,r2,r3	@ register r6 contains i + j
	SUB r4,r5,r6	@ f gets r5  r6, ie: (g + h)  (i + j)
	MOV r0,r4	@ returns f (r0 = r4)

	LDR r4, [sp,#0] @ restore register r4 for caller
	LDR r5, [sp,#4] @ restore register r5 for caller
	LDR r6, [sp,#8] @ restore register r6 for caller
	ADD sp,sp,#12	@ adjust stack to delete 3 items
	bx  lr		@ jump back to calling routine
