.globl _start
_start:
	mov sp,#0x10000
	@ r0 = g, r1 = h, r2 = I, r3 = j, r4 = f
	mov r0,#5
	mov r1,#4
	mov r2,#6
	mov r3,#7
	mov r4,#0
	bl ex

iloop:	b	iloop		@ infinite loop (for "termination")

ex:	@ label for function name
	PUSH {r4,r5,r6,lr}

	ADD r5,r0,r1	@ register r5 contains g + h
	ADD r6,r2,r3	@ register r6 contains i + j
	SUB r4,r5,r6	@ f gets r5  r6, ie: (g + h)  (i + j)
	MOV r0,r4	@ returns f (r0 = r4)

	POP {r4,r5,r6,lr}
	bx  lr		@ jump back to calling routine
